# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---
device_type: kv260
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 580

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility: public

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/zynqmp-kria-starter-psa/acs_suite.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: GITLAB_PRIVATE_TOKEN
      header: "PRIVATE-TOKEN"
      dataset: minimal

secrets:
  ARTIFACTORY_PASS: ARTIFACTORY_PASS
  ARTIFACTORY_USER: ARTIFACTORY_USER

context:
  boot_character_delay: 30
  test_character_delay: 30
  extra_kernel_args: rootwait

actions:
# Flash firmware and distro images and reset the device
- deploy:
    timeout:
      minutes: 40
    to: flasher
    images:
      ImageA:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      ImageB:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      sd:
        url: "https://gitlab.com/api/v4/projects/44378631/packages/generic/kv260-acs-image/24.07/ir-acs-live-image-generic-arm64.wic.xz"
        compression: xz
        partition: 1
        format: ext4
        overlays:
          lava: true

- boot:
    timeout:
      minutes: 480
    method: minimal
    parameters:
      kernel-start-message: 'EFI stub: Booting Linux Kernel...'
    prompts:
      - 'root@generic-arm64:~# '

- test:
    timeout:
      minutes: 60
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Upload-ACS-Logs
            description: "Upload-ACS-Logs"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - while [ $(systemctl show -p SubState --value acs_run-before-login-prompt) != "exited" ]; do echo "Waiting for tests to finish"; sleep 60; done
              - curl -fL https://getcli.jfrog.io/v2 | sh
              - cp jfrog /usr/bin/
              - chmod 755 /usr/bin/jfrog
              - cd /mnt
              - echo "CI_PROJECT_PATH={{ CI_PROJECT_PATH }}" > acs_results/buildata.txt
              - echo "CI_JOB_NAME={{ CI_JOB_NAME }}" >> acs_results/buildata.txt
              - echo "CI_JOB_ID={{ CI_JOB_ID }}" >> acs_results/buildata.txt
              - tar czf acs_results.tar.gz acs_results
              - |
                set +x; \
                echo "{{ ARTIFACTORY_HOST_IP }} {{ ARTIFACTORY_HOST_NAME }}" >> /etc/hosts;
                . /lava-${LAVA_JOB_ID}/secrets && \
                jfrog config add \
                  --insecure-tls=true artifactory-aws \
                  --interactive=false \
                  --artifactory-url={{ ARTIFACTORY_URL }} \
                  --user=${ARTIFACTORY_USER} \
                  --password=${ARTIFACTORY_PASS}
              - set -x;
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "acs_results.tar.gz",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/",
                      "flat": "false",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard "${build_name}" --max-builds=10 --max-days=30 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
        from: inline
        name: Upload-ACS-Logs
        path: inline/Upload-ACS-Logs.yaml
